##// END OF EJS Templates
Incorporated most of Aron Griffis suggestions for sh compatibility.
Incorporated most of Aron Griffis suggestions for sh compatibility.

File last commit:

r804:19388dcb default
r804:19388dcb default
Show More
run-tests
137 lines | 2.6 KiB | text/plain | TextLexer
Thomas Arendsen Hein
Remove bashisms and use /bin/sh instead of /bin/bash....
r544 #!/bin/sh -e
mpm@selenic.com
Add a simple testing framework...
r331
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 LANG="C"; export LANG
LC_CTYPE="C"; export LC_CTYPE
LC_NUMERIC="C"; export LC_NUMERIC
LC_TIME="C"; export LC_TIME
LC_COLLATE="C"; export LC_COLLATE
LC_MONETARY="C"; export LC_MONETARY
LC_MESSAGES="C"; export LC_MESSAGES
LC_PAPER="C"; export LC_PAPER
LC_NAME="C"; export LC_NAME
LC_ADDRESS="C"; export LC_ADDRESS
LC_TELEPHONE="C"; export LC_TELEPHONE
LC_MEASUREMENT="C"; export LC_MEASUREMENT
LC_IDENTIFICATION="C"; export LC_IDENTIFICATION
LC_ALL=""; export LC_ALL
TZ=GMT; export TZ
HGEDITOR=true; export HGEDITOR
HGMERGE=true; export HGMERGE
HGUSER="test"; export HGUSER
mpm@selenic.com
[PATCH] Set locale before run-tests does anything...
r488
mpm@selenic.com
[PATCH] umask for run-tests...
r489 umask 022
mpm@selenic.com
Add a simple testing framework...
r331 tests=0
failed=0
Thomas Arendsen Hein
Make tests work on Solaris:...
r798
HGTMP=""
cleanup_exit() {
rm -rf "$HGTMP"
exit $1
}
# Remove temporary files even if we get interrupted
trap "cleanup_exit 255" TERM KILL INT QUIT ABRT
HGTMP="${TMPDIR-/tmp}/hgtests.$RANDOM.$RANDOM.$RANDOM.$$"
(umask 077 && mkdir "$HGTMP") || {
echo "Could not create temporary directory! Exiting." 1>&2
exit 1
}
TESTDIR="$PWD"
mpm@selenic.com
Add a simple testing framework...
r331
mpm@selenic.com
[PATCH] Get run-tests working on 64-bit machines....
r473 if [ -d /usr/lib64 ]; then
lib=lib64
else
lib=lib
fi
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 INST="$HGTMP/install"
mpm@selenic.com
From: Andrew Thompson <andrewkt@aktzero.com>...
r397 cd ..
Thomas Arendsen Hein
Incorporated most of Aron Griffis suggestions for sh compatibility.
r804 if ${PYTHON-python} setup.py install --home="$INST" > tests/install.err 2>&1
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 then
rm tests/install.err
mv "$INST/bin/hg" "$INST/bin/hg.real"
(
Thomas Arendsen Hein
Use tabs instead of spaces where apropriate.
r803 echo '#!/bin/sh'
echo 'echo "+ hg $@"'
echo 'exec hg.real "$@"'
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 ) > "$INST/bin/hg"
chmod 755 "$INST/bin/hg"
else
mpm@selenic.com
Quiet successful test install in run-tests...
r398 cat tests/install.err
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 cleanup_exit 1
mpm@selenic.com
Quiet successful test install in run-tests...
r398 fi
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 cd "$TESTDIR"
mpm@selenic.com
From: Andrew Thompson <andrewkt@aktzero.com>...
r397
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 PATH="$INST/bin:$PATH"; export PATH
PYTHONPATH="$INST/$lib/python"; export PYTHONPATH
run_one() {
rm -f "$1.err"
mpm@selenic.com
Add a simple testing framework...
r331
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 mkdir "$HGTMP/$1"
cd "$HGTMP/$1"
mpm@selenic.com
Add a simple testing framework...
r331 fail=0
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 HOME="$HGTMP/$1"; export HOME
OUT="$HGTMP/$1.out"
OUTOK="$TESTDIR/$1.out"
ERR="$TESTDIR/$1.err"
mpm@selenic.com
run-tests: run tests given on the command line...
r362
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 if "$TESTDIR/$1" > "$OUT" 2>&1; then
Thomas Arendsen Hein
Use tabs instead of spaces where apropriate.
r803 : no error
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 else
echo "$1 failed with error code $?"
mpm@selenic.com
Add a simple testing framework...
r331 fail=1
fi
mpm@selenic.com
run-tests: run tests given on the command line...
r362
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 if [ -s "$OUT" -a ! -s "$OUTOK" ] ; then
cp "$OUT" "$ERR"
echo
echo "$1 generated unexpected output:"
cat "$ERR"
mpm@selenic.com
Add a simple testing framework...
r331 fail=1
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 elif [ -r "$OUTOK" ]; then
Thomas Arendsen Hein
Use tabs instead of spaces where apropriate.
r803 if diff -u "$OUTOK" "$OUT" > /dev/null; then
: no differences
else
if FIXME="`grep 'FIXME' \"$TESTDIR/$1\"`"; then
echo
echo "$1 failed, but this is ignored because of:"
echo "$FIXME"
else
cp "$OUT" "$ERR"
echo
echo "$1 output changed:"
diff -u "$OUTOK" "$ERR" || true
fail=1
fi
fi
mpm@selenic.com
Add a simple testing framework...
r331 fi
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 cd "$TESTDIR"
rm -f "$HGTMP/$1.out"
rm -rf "$HGTMP/$1"
mpm@selenic.com
run-tests: run tests given on the command line...
r362 return $fail
}
mpm@selenic.com
Add a simple testing framework...
r331
Thomas Arendsen Hein
Incorporated most of Aron Griffis suggestions for sh compatibility.
r804 TESTS="$*"
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 if [ -z "$TESTS" ] ; then
Thomas Arendsen Hein
Incorporated most of Aron Griffis suggestions for sh compatibility.
r804 TESTS=`ls test-* | grep -v "[.~]"`
mpm@selenic.com
run-tests: run tests given on the command line...
r362 fi
for f in $TESTS ; do
echo -n "."
Thomas Arendsen Hein
Incorporated most of Aron Griffis suggestions for sh compatibility.
r804 run_one $f || failed=`expr $failed + 1`
tests=`expr $tests + 1`
mpm@selenic.com
Add a simple testing framework...
r331 done
Thomas Arendsen Hein
Incorporated most of Aron Griffis suggestions for sh compatibility.
r804 echo
echo "Ran $tests tests, $failed failed."
mpm@selenic.com
Add a simple testing framework...
r331
Thomas Arendsen Hein
Incorporated most of Aron Griffis suggestions for sh compatibility.
r804 if [ $failed -gt 0 ] ; then
cleanup_exit 1
mpm@selenic.com
Add a simple testing framework...
r331 fi
Thomas Arendsen Hein
Make tests work on Solaris:...
r798 cleanup_exit 0